var parentHandle;
var parentCallBack;
var selectedItem;
var selectedState;
var selected_values = [];
var optionsetLabels = [];
var optionsetValues = [];
var index;


var searchbar = Ti.UI.createSearchBar({
	hintText : L('eApplicationSearch'),
	barColor : '#000',
	showCancel : false
});

function hidePopOver(e) {
	if (selectedItem !== '') {
		parentCallBack(parentHandle, selectedItem, optionsetValues[index], index, selectedState);
	}
	$.popoverWidgetWrapper.hide();
}


exports.setPopoverTypeAndData = function(popOverData) {
	
			parentHandle = popOverData.parentObj;
			parentCallBack = popOverData.parentCB;
			
			var rowTemplate = {
				properties: { 
					backgroundColor : '#dbdbdb'
				},
				childTemplates: [
			        {                            // Title 
			            type: 'Ti.UI.Label',     // Use a label for the title 
			            bindId: 'title',          // Maps to a custom info property of the item data
			            properties: {            // Sets the label properties
							width: Ti.UI.FILL,
							heigth: Ti.UI.FILL,
							left: 16
			            }
			        }
			    ]
			};
			if (popOverData.doSearchAndFilter) {
				var listView = Ti.UI.createListView({
					searchView : searchbar,
					height : popOverData.popoverHeight,
					backgroundColor : '#dbdbdb',
					templates: { 'template': rowTemplate},
					defaultItemTemplate: 'template'
				});
				$.popoverWidgetWrapper.setWidth(popOverData.popoverWidth);
			} else {
				var listView = Ti.UI.createListView({
					height : Ti.UI.SIZE,
					backgroundColor : '#dbdbdb',
					templates: { 'template': rowTemplate},
					defaultItemTemplate: 'template'
				});
				$.popoverWidgetWrapper.setWidth(270);
			}
			if (popOverData.popoverWidth > 270) {
				$.popoverWidgetWrapper.setWidth(popOverData.popoverWidth);
			}
			var tableViewRowContent = [];
			var i = 0;
			if (popOverData.content instanceof Array) {
				//In case we are passing the array we are displaying the array elements in the table
				if (popOverData.content[0] instanceof Object) {
					optionsetLabels = [];
					optionsetValues = [];
					for (i in popOverData.content) {
						optionsetLabels[i] = popOverData.content[i].label;
						optionsetValues[i] = popOverData.content[i].value;
						tableViewRowContent.push({ title: { text: optionsetLabels[i] }, properties: { searchableText: optionsetLabels[i] } });
					}
				} else {
					optionsetLabels = [];
					optionsetValues = [];
					//Copying the same value of content to both the arrays, as we need the index of the selected items to be passed to callback object
					optionsetLabels = popOverData.content;
					optionsetValues = popOverData.content;
					for (i in popOverData.content) {
						tableViewRowContent.push({ title: { text: popOverData.content[i] }, properties: { searchableText: popOverData.content[i] } });
					}
				}
			} else {
				//In case we are passing the object we are extracting the keys to display in the table
				var keys = Object.keys(popOverData.content);
				for (i in keys) {
					tableViewRowContent.push({ title: { text: keys[i] }, properties: { searchableText: keys[i] } });
				}
			}
			var section = Ti.UI.createListSection();
			section.setItems(tableViewRowContent);
			listView.sections = [section];
			listView.addEventListener('itemclick', function(e) {
				Ti.API.info('itemclick', e);
				var item = e.section.getItemAt(e.itemIndex);
				Ti.API.info('item', item);
				selectedItem = item.title.text;
				index = e.itemIndex;
				$.popoverWidgetWrapper.hide();
			});
			if (popOverData.doSearchAndFilter) {
				searchbar.addEventListener('return', function(e) {
					$.popoverWidgetWrapper.hide();
				});
			}
			//There is a jira defect raised https://jira.appcelerator.org/browse/AC-39
			//which basically is for the fact that the navbar is seen when popover is displayed
			//solution suggested is adding the View to a window and then using window as a content View
			var contentWindow = Ti.UI.createWindow({
				width : Ti.UI.SIZE,
				height : Ti.UI.SIZE,
				borderColor : '#CCC'
			});
			contentWindow.add(listView);
			$.popoverWidgetWrapper.setContentView(contentWindow);
			
};
